
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>用C#实现基于用C#实现基于TCP协议的网络通讯 / iVAN</title>

    <meta name="description" content="用C#实现基于用C#实现基于TCP协议的网络通讯 网络 TCP协议是一个基本的网络协议,基本上所有的网络服务都是基于TCP协议的,如HTTP,FTP等等,所以要了解网络编程就必须了解基于TCP协议的编程.然而TCP协议是一个庞杂的体系,要彻底的弄清楚它的实现不是一天两天的功夫,所幸的是在.net framework环境下,我们不必要去追究TCP协议底层的实现,一样可以很方便的编写出基于TCP协议进行网络通讯的程序. 要进行基于TCP协议的网络通讯,首先必须建立同远程主机的连接,连接地址通常包括两部分--主机名和端口,如www.yesky.c">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">用C#实现基于用C#实现基于TCP协议的网络通讯</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>网络</p>
<p>TCP协议是一个基本的网络协议，基本上所有的网络服务都是基于TCP协议的，如HTTP,FTP等等，所以要了解网络编程就必须了解基于TCP协议的编程。然而TCP协议是一个庞杂的体系，要彻底的弄清楚它的实现不是一天两天的功夫，所幸的是在.net framework环境下，我们不必要去追究TCP协议底层的实现，一样可以很方便的编写出基于TCP协议进行网络通讯的程序。</p>
<p>要进行基于TCP协议的网络通讯，首先必须建立同远程主机的连接，连接地址通常包括两部分——主机名和端口，如www.yesky.com:80中，www.yesky.com就是主机名，80指主机的80端口，当然，主机名也可以用IP地址代替。当连接建立之后，就可以使用这个连接去发送和接收数据包，TCP协议的作用就是保证这些数据包能到达终点并且能按照正确的顺序组装起来。</p>
<p>在.net framework的类库（Class Library）中，提供了两个用于TCP网络通讯的类，分别是TcpClient和TcpListener。由其英文意义显而易见，TcpClient类是基于TCP协议的客户端类，而TcpListener是服务器端，监听(Listen)客户端传来的连接请求。TcpClient类通过TCP协议与服务器进行通讯并获取信息，它的内部封装了一个Socket类的实例，这个Socket对象被用来使用TCP协议向服务器请求和获取数据。因为与远程主机的交互是以数据流的形式出现的，所以传输的数据可以使用.net framework中流处理技术读写。在我们下边的例子中，你可以看到使用NetworkStream类操作数据流的方法。</p>
<p>在下面的例子中，我们将建立一个时间服务器，包括服务器端程序和客户端程序。服务器端监听客户端的连接请求，建立连接以后向客户端发送当前的系统时间。</p>
<p>先运行服务器端程序，下面截图显示了服务器端程序运行的状况：</p>
<p>然后运行客户端程序，客户端首先发送连接请求到服务器端，服务器端回应后发送当前时间到客户端，这是客户端程序的截图：</p>
<p>发送完成后，服务器端继续等待下一次连接：</p>
<p>通过这个例子我们可以了解TcpClient类的基本用法，要使用这个类，必须使用System.Net.Socket命名空间，本例用到的三个命名空间如下：</p>
<p>using System; <br />using System.Net.Sockets; <br />using System.Text;//从字节数组中获取字符串时使用该命名空间中的类</p>
<p>首先讨论一下客户端程序，开始我们必须初始化一个TcpClient类的实例：</p>
<p>TcpClient client = new TcpClient(hostName, portNum);</p>
<p>然后使用TcpClient类的GetStream()方法获取数据流，并且用它初始化一个NetworkStream类的实例：</p>
<p>NetworkStream ns = client.GetStream();</p>
<p>注意，当使用主机名和端口号初始化TcpClient类的实例时，直到跟服务器建立了连接，这个实例才算真正建立，程序才能往下执行。如果因为网络不通，服务器不存在，服务器端口未开放等等原因而不能连接，程序将抛出异常并且中断执行。</p>
<p>建立数据流之后，我们可以使用NetworkStream类的Read()方法从流中读取数据，使用Write()方法向流中写入数据。读取数据时，首先应该建立一个缓冲区，具体的说，就是建立一个byte型的数组用来存放从流中读取的数据。Read()方法的原型描述如下：</p>
<p>public override int Read(in byte[] buffer,int offset,int size)</p>
<p>buffer是缓冲数组，offset是数据（字节流）在缓冲数组中存放的开始位置，size是读取的字节数目，返回值是读取的字节数。在本例中，简单地使用该方法来读取服务器反馈的信息：</p>
<p>byte[] bytes = new byte[1024];//建立缓冲区 <br />int bytesRead = ns.Read(bytes, 0, bytes.Length);//读取字节流</p>
<p>然后显示到屏幕上：</p>
<p>Console.WriteLine(Encoding.ASCII.GetString(bytes,0,bytesRead));</p>
<p>最后不要忘记关闭连接：</p>
<p>client.Close();</p>
<p>下面是本例完整的程序清单：</p>
<p>using System; <br />using System.Net.Sockets; <br />using System.Text;</p>
<p>namespace TcpClientExample <br />{ <br />public class TcpTimeClient <br />{ <br />private const int portNum = 13;//服务器端口，可以随意修改 <br />private const string hostName = "127.0.0.1";//服务器地址，127.0.0.1指本机</p>
<p>[STAThread] <br />static void Main(string[] args) <br />{ <br />try <br />{ <br />Console.Write("Try to connect to "+hostName+":"+portNum.ToString()+"\r\n"); <br />TcpClient client = new TcpClient(hostName, portNum); <br />NetworkStream ns = client.GetStream(); <br />byte[] bytes = new byte[1024]; <br />int bytesRead = ns.Read(bytes, 0, bytes.Length);</p>
<p>Console.WriteLine(Encoding.ASCII.GetString(bytes,0,bytesRead));</p>
<p>client.Close(); <br />Console.ReadLine();//由于是控制台程序，故为了清楚的看到结果，可以加上这句</p>
<p>} <br />catch (Exception e) <br />{ <br />Console.WriteLine(e.ToString()); <br />} <br />} <br />} <br />}</p>
<p>上面这个例子清晰地演示了客户端程序的编写要点，下面我们讨论一下如何建立服务器程序。这个例子将使用TcpListener类，在13号端口监听，一旦有客户端连接，将立即向客户端发送当前服务器的时间信息。</p>
<p>TcpListener的关键在于AcceptTcpClient()方法，该方法将检测端口是否有未处理的连接请求，如果有未处理的连接请求，该方法将使服务器同客户端建立连接，并且返回一个TcpClient对象，通过这个对象的GetStream方法建立同客户端通讯的数据流。事实上，TcpListener类还提供一个更为灵活的方法AcceptSocket()，当然灵活的代价是复杂，对于比较简单的程序，AcceptTcpClient()已经足够用了。此外，TcpListener类提供Start()方法开始监听，提供Stop()方法停止监听。</p>
<p>首先我们使用端口初始化一个TcpListener实例，并且开始在13端口监听：</p>
<p>private const int portNum = 13; <br />TcpListener listener = new TcpListener(portNum); <br />listener.Start();//开始监听</p>
<p>如果有未处理的连接请求，使用AcceptTcpClient方法进行处理，并且获取数据流：</p>
<p>TcpClient client = listener.AcceptTcpClient(); <br />NetworkStream ns = client.GetStream();</p>
<p>然后，获取本机时间，并保存在字节数组中，使用NetworkStream.Write()方法写入数据流，然后客户端就可以通过Read()方法从数据流中获取这段信息：</p>
<p>byte[] byteTime = Encoding.ASCII.GetBytes(DateTime.Now.ToString()); <br />ns.Write(byteTime, 0, byteTime.Length); <br />ns.Close();//不要忘记关闭数据流和连接 <br />client.Close();</p>
<p>服务器端程序完整的程序清单如下：</p>
<p>using System; <br />using System.Net.Sockets; <br />using System.Text;</p>
<p>namespace TimeServer <br />{ <br />class TimeServer <br />{ <br />private const int portNum = 13;</p>
<p>[STAThread] <br />static void Main(string[] args) <br />{ <br />bool done = false; <br />TcpListener listener = new TcpListener(portNum); <br />listener.Start(); <br />while (!done) <br />{ <br />Console.Write("Waiting for connection..."); <br />TcpClient client = listener.AcceptTcpClient();</p>
<p>Console.WriteLine("Connection accepted."); <br />NetworkStream ns = client.GetStream();</p>
<p>byte[] byteTime = Encoding.ASCII.GetBytes(DateTime.Now.ToString());</p>
<p>try <br />{ <br />ns.Write(byteTime, 0, byteTime.Length); <br />ns.Close(); <br />client.Close(); <br />} <br />catch (Exception e) <br />{ <br />Console.WriteLine(e.ToString()); <br />} <br />}</p>
<p>listener.Stop(); <br />} <br />} <br />}</p>
<p>把上面两段程序分别编译运行，OK，我们已经用C#实现了基于TCP协议的网络通讯，怎么样？很简单吧！</p>
<p>使用上面介绍的基本方法，我们可以很容易的编写出一些很有用的程序，如FTP，电子邮件收发，点对点即时通讯等等，你甚至可以自己编制一个QQ来！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:31:32</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f/" title="程序">程序</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e5%ae%a2%e6%88%b7%e7%ab%af/" title="客户端">客户端</a>, <a href="https://www.iamivan.net/tag/ftp-c/" title="ftp c&num;">ftp c&num;</a>, <a href="https://www.iamivan.net/tag/c-ftp/" title="c&num;  ftp">c&num;  ftp</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e6%b5%81/" title="数据流">数据流</a>, <a href="https://www.iamivan.net/tag/c-%e8%af%bb%e5%8f%96%e5%ad%97%e8%8a%82%e6%95%b0/" title="c&num;读取字节数">c&num;读取字节数</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93%e8%bf%9e%e6%8e%a5-c/" title="数据库连接 c&num;">数据库连接 c&num;</a>, <a href="https://www.iamivan.net/tag/activemq%e7%9b%91%e5%90%ac%e8%bf%9e%e6%8e%a5%e5%bc%82%e5%b8%b8c/" title="activemq监听连接异常c&num;">activemq监听连接异常c&num;</a>, <a href="https://www.iamivan.net/tag/%e7%9b%91%e5%90%ac-c-%e6%95%b0%e6%8d%ae/" title="监听 c&num; 数据">监听 c&num; 数据</a>, <a href="https://www.iamivan.net/tag/tcpclient/" title="tcpclient">tcpclient</a>, <a href="https://www.iamivan.net/tag/%e8%bf%9e%e6%8e%a5%e6%9c%aa%e5%bb%ba%e7%ab%8b/" title="连接未建立">连接未建立</a>, <a href="https://www.iamivan.net/tag/c-%e5%ae%89%e5%8d%93tcp/" title="c&num;安卓tcp">c&num;安卓tcp</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>用C#实现基于用C#实现基于TCP协议的网络通讯的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bo5Egp.html" rel="bookmark">用C&num;实现基于TCP协议的网络通讯</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网络 TCP协议是一个基本的网络协议,基本上所有的网络服务都是基于TCP协议的,如HTTP,FTP等等,所以要了解网络编程就必须了解基于TCP协议的编程.然而TCP协议是一个庞杂的体系,要彻底的弄清楚它的实现不是一天两天的功夫,所幸的是在.net framework环境下,我们不必要去追究TCP协议底层的实现,一样可以很方便的编写出基于TCP协议进行网络通讯的程序. 要进行基于TCP协议的网络通讯,首先必须建立同远程主机的连接,连接地址通常包括两部分--主机名和端口,如www.yesky.c			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdL6y6p.html" rel="bookmark">艾伟&lowbar;转载：用C&num;实现基于TCP协议的网络通讯</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				TCP协议是一个基本的网络协议,基本上所有的网络服务都是基于TCP协议的,如HTTP,FTP等等,所以要了解网络编程就必须了解基于TCP协议的编程.然而TCP协议是一个庞杂的体系,要彻底的弄清楚它的实现不是一天两天的功夫,所幸的是在.net framework环境下,我们不必要去追究TCP协议底层的实现,一样可以很方便的编写出基于TCP协议进行网络通讯的程序.  要进行基于TCP协议的网络通讯,首先必须建立同远程主机的连接,连接地址通常包括两部分--主机名和端口,如www.yesky.com:8			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJA1wJp.html" rel="bookmark">&lbrack;转贴&rsqb;基于UDP、TCP协议的C&num;网络编程之二</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自新浪&quot;烈·翼·焚·天&quot;的博客,原文地址:http://blog.sina.com.cn/s/blog_4c459776010009c3.html~type=v5_one&amp;label=rela_nextarticle 第二截,讲讲基于TCP协议的网络编程,与UDP不同的是,基于TCP协议的编程的服务器端有一个监听对象:TcpListener,它负责监听来自客户端的消息并处理,并且必须在保持连接的情况下与客户端保持互动,下面举个例子,TCP不怎么复杂,只是综合要求较高,如果想编			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXjJdyb.html" rel="bookmark">大型分布式网站架构设计与实践 第一章《面向服务的体系架构（SOA&rpar;》1&period;1基于TCP协议的RPC</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1基于TCP协议的RPC 1.1.1RPC名词理解 RPC的全称是Remote Process Call,即远程过程调用,它应用广泛,实现方式也很多,拥有RMI,WebService等诸多成熟的方案,在业界得到了广泛的应用.单台服务器的处理能力受硬件成本的限制,不可能无限制的提升,RPC将原来的本地调用转变为调用远端的服务器上的方法,给系统的处理能力和吞吐量带来了近乎无限制的提升,这是系统发展到一定阶段必然性的改革,也是实现分布式计算的基础. 如图1-2所示,RPC的实现包括客户端和服务端,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mxo7vjb.html" rel="bookmark">tcp-C&num; 如何使用socket实现基于TCP协议传输数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C# 如何使用socket实现基于TCP协议传输数据 我使用Socket.Send和Socket.BeginReceive完成了上位机通讯软件的编写,但是连接下位机经过分析抓包软件得到的数据包,发现似乎与标准TCP协议有出入.具体来讲是这样的: 首先根据TCP协议,数据交换的规范应该是这样的http://blog.csdn.net/moonhnney/article/details/5604677 数据交换: a ----&gt;b a 发送数据完毕,(PSH,ACK) aseq = x,a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1N6Dxp.html" rel="bookmark">Java基于Tcp协议的socket编程实例&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Java基于Tcp协议的socket编程方法,分享给大家供大家参考.具体分析如下: 以下是一对一的通信编程实现,后续会继续学习一个服务器监听多个客户端的实现. 这里用到的主要步骤如下: 第一步:以特定端口(如4800)新建socket对象 第二步:以系统输入设备构造BufferedReader对象,该对象用于接收系统键盘输入的字符 第三步:以socket对象 得到输出流来构造PrintWriter 第四步:以socket对象得到输入流来构造相应的BufferedReader对象,该			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJAm4Dp.html" rel="bookmark">&lbrack;转贴&rsqb;基于UDP、TCP协议的C&num;网络编程之一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自新浪&quot;烈·翼·焚·天&quot;的博客,原文地址:http://blog.sina.com.cn/s/blog_4c459776010009bp.html 写这篇之前,先简单介绍一下TCP.UDP协议,深的讲不出来,有不明白的请问我秘书Dawnh同学.     TCP(传输控制协议)是 TCP/IP 协议栈中的传输层协议,它通过序列确认以及包重发机制,提供可靠的数据流发送和到应用程序的虚拟连接服务.与IP协议相结合, TCP组成了因特网协议的核心.     UDP(用户数据报协议)是ISO参			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRGrRp.html" rel="bookmark">C&num;基于TCP协议的服务器端和客户端通信编程的基础教程&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				运行在TCP之上常见的网络应用协议有比如HTTP.FTP.SMTP.POP3.IMAP. TCP是TCP/IP体系中最重要的传输协议,它提供全双工和可靠交付的服务,是大多数应用协议工作的基础. TCP是一种面向连接(连接导向)的,可靠的,基于字节流的传输层通信协议. TCP的工作过程 建立连接 传输数据 连接的终止 TCP的主要特点1.TCP是面向连接的协议 2.是端到端的通信.每个TCP连接只能有两个端点,而且只能一对一通信,不能点对多的 的直接通信 3.高可靠性 4.全双工方式传输 5.数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAajjvM.html" rel="bookmark">linux网络编程之socket（十四） 基于UDP协议的网络程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.下图是典型的UDP客户端/服务器通讯过程 下面依照通信流程,我们来实现一个UDP回射客户/服务器 #include &lt;sys/types.h&gt; #include &lt;sys/socket.h&gt;  ssize_t send(int sockfd, const void *buf, size_t len, int flags); ssize_t sendto(int sockfd, const void *buf, size_t len, int flags, const struc			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAPnAb.html" rel="bookmark" class="title">全国IP地址分配表（二）</a>
					<div>
						ip地址 cnc.ac.cn,中国科学院网,北京,北京,CN,159.226.*.* gb.com.cn,中国金桥网,北京,北京,CN,203.93.66.* gb.com.cn,中国金桥网,北京,北 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNl9yz.html" rel="bookmark" class="title">徐金胜：详解百度区域性搜索结果不同的原因</a>
					<div>
						想必研究百度的都知道百度在不同地区搜索一些关键词的时候搜索结果不同,而这个也就是百度已经测试很久了的一项功能:用户输入某一些关键字的时候, 百度会调用用户的IP然后根据用户IP所在的城市,来提高城市+ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBWG5b.html" rel="bookmark" class="title">Android系统获取Root权限原理详解</a>
					<div>
						android root权限破解分析 许多机友新购来的Android机器没有破解过Root权限,无法使用一些需要高权限的软件,以及进行一些高权限的操作,其实破解手机Root权限是比较简单及安全的,破解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjR03p.html" rel="bookmark" class="title">Oracle控制文件的重建方法</a>
					<div>
						场景:存储介质被破坏,造成控制文件丢失,需更换硬盘,并重新建立控制文件. (1)修改初始化参数control_files,改变控制文件位置 SQL&gt; ALTER  SYSTEM  SET  CO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx52Kb.html" rel="bookmark" class="title">PS合成头顶冒火的鹿王图片</a>
					<div>
						  套索工具选择下图所示的岩石,然后右键选择&quot;通过拷贝的图层&quot;.   十三.然后调整岩石的大小,如下图.   十四.选择大岩石图层,选择菜单:滤镜 &gt; 模糊 &gt; 高斯模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baddwQz.html" rel="bookmark" class="title">给Excel表格设置边框的三项常用操作</a>
					<div>
						辛辛苦苦编辑好的Excel表格,一打印,怎么没有边框呀!如何快速为表格添加边框呢? ·快速为表格添加边框 如果不想设计什么特别的边框,直接用系统的网格线为表格添加边框是最方便的: 执行&quot;文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmdZZz.html" rel="bookmark" class="title">好照片巧用拼图技巧：拼出最萌喵星人</a>
					<div>
						图1 在这个萌宠横行的时代,谁家没有一两个让你又爱又恨的喵星人呢,用照片记录下猫咪的各种样子,想要时时刻刻一览它们笨笨可爱的姿态,一张照片怎么够?好照片的拼图功能可以帮你拼出你萌宠可爱的样子,一起来D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg30KmM.html" rel="bookmark" class="title">QQ电脑管家文件保险柜为文件加密</a>
					<div>
						  1.文件保险柜可以在QQ电脑管家的工具箱中找到. 新建保险柜给文件加密 1.为保险柜起个名字,并输入两次密码就可以创建保险柜了.不过为了防止自己忘记密码,建议大家给新建的保险柜绑定QQ帐号,以便保 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEWoOp.html" rel="bookmark" class="title">完美兼容各大浏览器的jQuery仿新浪图文淡入淡出间歇滚动特效&lowbar;jquery</a>
					<div>
						1.效果及功能说明 仿新浪微博图片文字列表上下淡进淡出间歇上下滚动 2.实现原理 首先要设定div内只能显示4个图片那么多出来的图片会自动隐藏然后在给图片添加一个动画的事件让他们可以滚动的播放出来上下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVVeOb.html" rel="bookmark" class="title">服务器-路由器的端口映射是怎么做的</a>
					<div>
						问题描述 路由器的端口映射是怎么做的 比如说我有一台服务器IP是192.168.2.4,公网地址是222.2.22.2,映射的话是不是先在2.4这台服务器上把相应的端口开了,然后再在路由器上配置命令, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7lN2z.html" rel="bookmark" class="title">Hibernate中表与表之间的级联关系</a>
					<div>
						问题描述 Hibernate中表与表之间的级联关系 2C 投票系统1. # 需求: 用户可以创建投票也可以_参与投票2.数据库结构如下 1.感觉VOTER表应该是 多对多 的中间表2.VOTE表与US ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA1k2M.html" rel="bookmark" class="title">Windows魔法堂：解决&OpenCurlyDoubleQuote;由于启动计算机时出现页面文件配置问题&period;&period;&period;&period;&period;&period;&period;&rdquo;</a>
					<div>
						一.前言   昨晚终于在VirtualBox中安装好Win7了,但在系统启动后弹出窗报&quot;由于启动计算机时出现页面文件配置问题.......&quot;,于是度娘一下.以下记录以供日后查阅.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPVkvp.html" rel="bookmark" class="title">考察数据科学家支持向量机（SVM）知识的25道题，快来测测吧</a>
					<div>
						更多深度文章,请关注云计算频道:https://yq.aliyun.com/cloud Introduction   机器学习强大如一座军械库,里面有各种威力惊人的武器,不过你首先得学会如何使用.举个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RY4Dz.html" rel="bookmark" class="title">老司机教你如何假装拥有一部 iPhone X</a>
					<div>
						天气冷了,加上双11将至,各路单身狗们纷纷活跃起来,在朋友圈花式推销自己,其中当属晒 iPhone X最为装逼. 比如这样, 这样, 这样. 但是,这些都是真的吗?当然不是,距离 iPhone X 开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKnQjz.html" rel="bookmark" class="title">myeclipse中servlet获取网页信息。</a>
					<div>
						问题描述 大侠们,跪求了.相当于页面中右击获取源代码那样的信息.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBm3KM.html" rel="bookmark" class="title">PHP的异步并行扩展Swoole已收录到PHP官方扩展库</a>
					<div>
						PHP的异步并行扩展Swoole已收录到PHP官网扩展库pecl.php.net.最新的版本是swoole-1.6.9.国内程序员组织的开源PHP扩展项目,能够添加到pecl中的并不多,目前仅有yaf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRq53b.html" rel="bookmark" class="title">内蒙古乌兰察布建成完整的智慧城市体系</a>
					<div>
						由内蒙古乌兰察布市集宁区党委.政府主办的&quot;智慧集宁&quot;近日上线运行.目前,集宁区已建立平安城市.智慧城管.智慧公交等10个模块,形成了比较完整的智慧城市体系. 未来,集宁区将大力推行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Rgrqb.html" rel="bookmark" class="title">Android编程学习之异步加载图片的方法&lowbar;Android</a>
					<div>
						本文实例讲述了Android编程学习之异步加载图片的方法.分享给大家供大家参考,具体如下: 最近在android开发中碰到比较棘手的问题,就是加载图片内存溢出.我开发的是一个新闻应用,应用中用到大量的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKJYAz.html" rel="bookmark" class="title">libcurl get post http</a>
					<div>
						一.              概念   1.         为什么要使用libcurl   1)        作为http的客户端,可以直接用socket连接服务器,然后对到的数据进行http解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRAY2p.html" rel="bookmark" class="title">用了FreeTextBox后 pages validateRequest&equals;&amp;amp&semi;amp&semi;quot&semi;false&amp;amp&semi;amp&semi;quot&semi;的问题</a>
					<div>
						问题描述 在ASP.NET中,添加新闻等页面,用了FreeTextBox后就必须在Web.config中设置pagesvalidateRequest=&quot;false&quot;么,这样做是不是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye0BkM.html" rel="bookmark" class="title">PMC为数据中心推出Smart系列存储方案，实现高速IO</a>
					<div>
						  12/9/2015,引领大数据连接.传送以及存储,提供创新半导体及软件解决方案的PMC公司(纳斯达克代码:PMCS)今日发布HBA 1000系列的12Gb/s SAS/SATA HBA卡,这是专为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xgBVb.html" rel="bookmark" class="title">雅虎继续收缩战线：卖不掉就毁掉</a>
					<div>
						3月12日,据科技媒体VentureBeat报道,雅虎今天在其2016年第一季度进度报告中透露了即将关闭若干产品和地区网站的计划.雅虎在上一次的财报电话会议中表示,该公司将专注于七个核心消费者产品:邮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRyaop.html" rel="bookmark" class="title">怎么样零基础学习开发HTML5&quest;有什么推荐书籍和学习方法？</a>
					<div>
						我做web大概有八年的时间,今天主要给新手想要做HTML5开发的新手简单说下HTML5能做为什么以及未来的发展和一个系统的学习规划,目前HTML5有多火,不用我说大家都清楚,很多其他行业想转行做HTM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xOGAb.html" rel="bookmark" class="title">高效的面试方式：结对编程</a>
					<div>
						导读:面试是技术研发企业永恒的话题.什么样的面试方式才是最高效的?资深Java程序员Rod Hilton 5月27日在博客文章Different Kind of Technical Interview ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze07ejp.html" rel="bookmark" class="title">做钻展和直通车的不同思路浅析</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 最近在接手做店铺的钻展投放,一共涉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvY5JWb.html" rel="bookmark" class="title">SQL Server中减小Log文件尺寸的方法分享&lowbar;MsSql</a>
					<div>
						首先use [数据库名称];exec sp_helpfile; 使用sp_helpfile查询可知道log 文件的逻辑名称,然后就可以利用DBCC来减小LOG文件BACKUP LOG [数据库名] W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZjmNz.html" rel="bookmark" class="title">php遍历文件夹和文件列表示例分享&lowbar;php实例</a>
					<div>
						为PHP遍历目录和文件列表写了一个简单的类,并附上使用实例,大家参考使用吧 复制代码 代码如下: &lt;?phpdefine('DS', DIRECTORY_SEPARATOR); class ge ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44LXLz.html" rel="bookmark" class="title">Javascript实例教程&lpar;19&rpar; 使用HoTMetal&lpar;1&rpar;&lowbar;基础知识</a>
					<div>
						HotMetal PRO 6.0是强大易用的网站编辑和发布工具.在本教程中我们在HotMetal中使用javascript.在HotMetal中,JavaScript支持是基于HotMetal为你提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLQldM.html" rel="bookmark" class="title">怎么把c&plus;&plus;的源代码导入vs中。。</a>
					<div>
						问题描述 怎么把c++的源代码导入vs中.. 怎么把c++的源代码导入vs中....源代码文件里,没有后缀为sln的文件. 解决方案 C++源代码什么格式的 ,如果是VC6.0编译的 就直接在vs中新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2rdYz.html" rel="bookmark" class="title">tomcat7&period;0上能发布probe吗？急急急！！！！！！！！</a>
					<div>
						问题描述 tomcat7.0上能发布probe吗?急急急!!!!!!!! 如题,在tomcat6.0发布成功,可以监测,但是7.0的失败. 请问有发布成功的吗? 操作流程是什么??谢谢..... 暂时 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
